var fluent = require("vows-fluent"),
	Topic = fluent.Topic,
	request = require("request"),
	defaults = {},
	util = require("util"),
	test_uri = /^(GET|POST|PUT|HEAD|DELETE)(.*)/;

exports.Is = {
	get a() {
		return this;
	},
	"request": function _request(url) {
		this._topic.set(function _topic() {
			var cb = this.callback;
			defaults.server.factory(function(server) {
				var options = {};
				var match = url && url.match(test_uri);
				if (match) {
					options.method = match[1];
					options.uri = defaults.server.uri + match[2].substr(1);
				} else {
					options.uri = defaults.server.uri + uri	
				}
				request(options, function(err, res, body) {
					server.close();
					cb(err, res);
				});
			});
		});
		return this._topic.parent();
	},
	"property": function _property(name) {
		this._topic.set(function _topic(topic) {
			return topic[name];
		});
		return this._topic.parent();
	}
};

Object.defineProperty(Topic, "is", {
	"set": function _set() {},
	"get": function _get() {
		var i = Object.create(exports.Is);
		i._topic = this;
		return i;
	}
});

exports.config = function _init(obj) {
	Object.keys(obj).forEach(function _each(key) {
		defaults[key] = obj[key];
	});
};

Object.keys(fluent).forEach(function(key) {
	exports[key] = fluent[key];
});